// This is the null frontend. It is functional for most cases, but it won't display anything or accept inputs. It's meant to be the most simple implementation of the API possible, without external dependencies. As a developer, you can use this as a clean slate of sorts.

// EVENTS
struct ENGINE_EVENT * engine_event_get() {
	struct ENGINE_EVENT * event = engine_memory_alloc(NULL,sizeof(struct ENGINE_EVENT));
	struct ENGINE_EVENT_NONE * data = engine_memory_alloc(NULL,sizeof(struct ENGINE_EVENT_NONE));
	event->type = ENGINE_EVENT_TYPE_NONE;
	event->data = data;
	return event;
}

// TEXTURE
struct ENGINE_TEXTURE * engine_texture_create(int width,int height) {
	struct ENGINE_TEXTURE * texture = engine_memory_alloc(NULL,sizeof(struct ENGINE_TEXTURE));
	struct ENGINE_FRONTEND_TEXTURE * fe_texture = engine_memory_alloc(NULL,sizeof(struct ENGINE_FRONTEND_TEXTURE));
	texture->width = width;
	texture->height = height;
	texture->fe_texture = fe_texture;
	return texture;
}

void engine_texture_destroy(struct ENGINE_TEXTURE * engine_texture) {
	engine_memory_free(engine_texture -> fe_texture);
	engine_memory_free(engine_texture);
}

struct ENGINE_COLOR engine_texture_color_get(struct ENGINE_TEXTURE * engine_texture,int x,int y) {
	struct ENGINE_COLOR color;
	color.r = 0;
	color.g = 0;
	color.b = 0;
	color.a = 255;
	return color;
}

// COLOR
void engine_color_set(unsigned char r,unsigned char g,unsigned char b,unsigned char a) {
}

// RENDERTARGET
struct ENGINE_TEXTURE * engine_rendertarget;
void engine_rendertarget_set(struct ENGINE_TEXTURE * texture) {
	engine_rendertarget = texture;
}

void engine_rendertarget_draw_point(int x,int y) {
}

// TIME
long long engine_frontend_time = 0;
long long engine_time_get() {
	engine_frontend_time += 1;
	return engine_frontend_time;
}

void engine_time_sleep(int ms) {
}

// WINDOW
struct ENGINE_WINDOW * engine_window_create(int width,int height,char * title) {
	struct ENGINE_WINDOW * window = engine_memory_alloc(NULL,sizeof(struct ENGINE_WINDOW));
	struct ENGINE_TEXTURE * texture = engine_texture_create(width,height);
	struct ENGINE_FRONTEND_WINDOW * fe_window = engine_memory_alloc(NULL,sizeof(struct ENGINE_FRONTEND_WINDOW));
	window -> texture = texture;
	window -> fe_window = fe_window;
	return window;
}

void engine_window_present(struct ENGINE_WINDOW * window) {
}

void engine_window_destroy(struct ENGINE_WINDOW * window) {
	engine_memory_free(window -> texture);
	engine_memory_free(window -> fe_window);
	engine_memory_free(window);
}